laravel/routes/web.php
<?php

Route::redirect('/', 'login');

Route::view('email-test', 'email');

Auth::routes();

#Se redirecciona la ruta de registro a inicio de sesión
Route::redirect('register', 'login');

Route::view('under-construction', 'errors.under-construction')->name('under-construction');

Route::get('pdf-event', function(){

    $ticket = App\Ticket::first();

    return view('helpdesk.tickets.pdf.event', compact('ticket'));
});

#Rutas que requieren autenticación
Route::group(['middleware' => 'auth'], function () {


    Route::get('/home', 'DashboardController@index');


    Route::get('/', 'DashboardController@index')->name('home');
     

    #Notificaciones
    Route::get('notifications', 'NotificationsController@index')->name('notifications');
    Route::post('notification/{notification}/read', 'NotificationsController@read')->name('read-notification');
    Route::post('notification/archive', 'NotificationsController@destroy')->name('archive-notification');
    Route::get('notification/list-archive', 'NotificationsController@list_archive')->name('list-archive');


    #Busqueda avanzada
    Route::get('search', 'TicketController@advance_search')->name('advance-search');
    

    #Ticket
    Route::resource('tickets', 'TicketController');
    Route::post('tickets/archive', 'TicketController@archive_tickets')->name('archive-tickets');
    Route::get('ticket_list_archive', 'TicketController@list_archive')->name('list-archive-tickets');
    Route::get('tickets/{ticket}/show_deleted', 'TicketController@show_deleted')->name('show_deleted');
    Route::post('tickets/unarchive', 'TicketController@unarchive_tickets')->name('unarchive-tickets');
    Route::post('{ticket}/set-public-comment', 'TicketController@set_public_comment')->name('public-comment')->middleware('ticket_owner');
    // Route::post('{ticket}/set-internal-comment', 'TicketController@set_internal_comment')->name('internal-comment')->middleware('role:admin,agent,manager');
    Route::post('tickets/{ticket}/download', 'TicketController@to_pdf')->name('export_ticket_to_pdf');

    #Reabrir ticket
    Route::post('reopen_ticket/{ticket}', 'ReopenTicketController@reopen_ticket_action')->name('reopen_ticket')->middleware('role:company,agent');
    Route::get('read_reopen_ticket/{reopen_ticket}', 'ReopenTicketController@mark_reopen_ticket_as_read')->name('read_reopen_ticket');
    

    #Tareas
    Route::resource('tickets.tasks', 'TaskController')->only(['store', 'show', 'update', 'destroy']);
    Route::post('tickets/{ticket}/tasks/{tasks}/start_end_task', 'TaskController@start_end_task')->name('start-end-task');
    Route::get('tasks', 'TaskController@index')->name('agent-tasks')->middleware('role:agent');
    Route::post('tickets/{ticket}/tasks/{tasks}/reassing', 'TaskController@reassign')->name('reassing-task');
    Route::resource('tickets.tasks.events', 'TaskEventController');
    

    #Asignar proyecto
    Route::post('ticket/{ticket}/assign_to_project', 'ProjectTicketController@assign_ticket_to_project')->name('assign_to_project');

    #Departamentos
    Route::resource('departments', 'DepartmentController');
    Route::get('departments/{department}/agents', 'DepartmentController@get_department_agents')->name('get_department_agents');


    #Grupos de Departamentos
    Route::resource('departments.groups', 'DepartmentGroupController');
    

    #Agentes
    Route::resource('agents', 'AgentController');
    

    #Compañias
    Route::resource('companies', 'CompanyController');
    

    #Equipos
    Route::resource('companies.gears', 'GearController')->except(['create']);
    Route::resource('companies.gears.modules', 'GearModuleController');
    

    Route::post('insert/{module}/into/{gear}', 'GearModuleController@insert_module')->name('insert_module');
    Route::post('remove/{module}', 'GearModuleController@remove_module')->name('remove_module');


    Route::get('{type}/get-brands', 'GearController@get_brands')->name('get_brands');
    Route::get('{brand}/get-models', 'GearController@get_models')->name('get_models');
    Route::get('{company}/{model}/gears', 'GearController@get_gears_by_model')->name('get_gears_by_model');
    Route::post('reassing/{gear}', 'GearController@reassign_gear_to_zone')->name('reassign_gear_to_zone');
    Route::post('companies/{company}/gears/search', 'GearController@search_gear')->name('search_gear');
    Route::post('companies/{company}/gears/download', 'GearController@download_company_gear')->name('download_company_gear');


    #Zonas de compañias
    Route::resource('companies.zones', 'CompanyZonesController');
    
    
    #Tipos de contacto
    Route::resource('contact-types', 'CompanyUserTypeController');


    #Contactos de compañias
    Route::resource('companies.contacts', 'CompanyUserController');
    Route::get('{zone}/get_contacts', 'CompanyUserController@get_zone_contacts')->name('get_zone_contacts');


    #Catalogos de contacto
    Route::resource('companies.contact-catalogs', 'ContactCatalogController');


    #Zonas usuarios
    Route::resource('zoneusers', 'ZoneUserController');


    #Marcas de equipo
    Route::resource('brands', 'GearBrandController')->except(['create', 'edit']);
    

    #Agregar tipos de equipo a marcas
    Route::resource('brands.types', 'BrandTypeController');


    #Tipos de equipo
    Route::resource('types', 'GearTypeController')->except(['index', 'create', 'edit']);


    #Modelos de equipo
    Route::resource('brands.types.models', 'GearModelController')->except(['create', 'edit']);
    

    #Garantias
    Route::resource('warranties', 'WarrantyController');


    #Coberturas
    Route::resource('coverages', 'CoverageController');
    

    #Contratos
    Route::resource('contracts', 'ContractController');
    

    #Acuerdos se servicio (SLA)
    Route::resource('sla', 'SLAController');
    

    #Opciones ticket
    Route::resource('ticket-options', 'TicketOptionController');    


    #Estatus ticket
    Route::resource('status', 'StatusController');
    

    #Severidad ticket
    Route::resource('severity', 'SeverityController');
    

    #Categorias ticket
    Route::resource('category', 'CategoryController');
    Route::resource('category.subcategory', 'SubCategoryController');
    

    #Perfil 
    Route::resource('profile', 'ProfileController');
    

    #Directorio
    Route::resource('directory', 'DirectoryController');


    #Encuestas
    Route::resource('users', 'UserController');
    

    #Encuestas
    Route::resource('surveys', 'SurveyController');


    #Preguntas
    Route::resource('surveys.questions', 'QuestionController');


    #Reportes
    Route::get('reports', 'ReportController@index')->name('reports');
    Route::get('reports/{company}/contacts', 'ReportController@get_company_contacts')->name('get_company_contacts');
    Route::get('reports/{company}/contracts', 'ReportController@get_company_contracts')->name('get_company_contracts');
    Route::get('reports/{company}/company_gears', 'ReportController@get_company_gears')->name('get_company_gears');
    Route::get('reports/{company}/coverages', 'ReportController@get_company_coverages')->name('get_company_coverages');
    Route::post('reports/get_report', 'ReportController@get_report')->name('get_report');



    #Proyectos por compania
    Route::resource('companies.projects', 'CompanyProjectController');
    Route::post('companies/{company}/projects/{project}/project_ticket', 'ProjectController@project_ticket')->name('new-project-ticket');

    #Proyectos general
    Route::resource('projects', 'ProjectController');
    Route::get('project/details', 'ProjectController@project_details')->name('project_details');
    Route::post('project/{project}/cancel', 'ProjectController@cancel_project')->name('cancel_project');
    Route::post('project/{project}/active', 'ProjectController@active_project')->name('active_project');

    #Inventario
    Route::resource('inventories', 'InventoryController');
    Route::resource('inventories.stock', 'StockController');
    Route::post('inventories/{inventory}/stock/{stock}/assign_company_to_gear', 'StockController@assign_gear_to_company')->name('assign_gear_to_company');

    #Cotizaciones
    Route::resource('companies.projects.quotations', 'QuotationController');
    Route::post('companies/{company}/projects/{project}/validate_quotation', 'QuotationController@validate_quotation')->name('validate_quotation');
});

laravel/app/Gear.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Gear extends Model
{
    
	protected $table   = 'gears';
    public $timestamps = true;
    protected $guarded = [];

	public function type(){

		return $this->belongsTo('App\GearType', 'type_id', 'id');

	}

	public function brand(){

		return $this->belongsTo('App\GearBrand', 'brand_id', 'id');

	}

	public function model(){

		return $this->belongsTo('App\GearModel', 'model_id', 'id');

	}

	public function modules(){

		return $this->hasMany('App\GearModule', 'gear_id', 'id');

	}

	public function tickets(){

		return $this->hasMany('App\Ticket', 'gear_id', 'id');
	}


	public function getAllModulesAttribute()
	{
		$all_modules = collect([]);
		$next_modules = collect($this->modules);
		
		while (!is_null($next_modules)) {

		    $add_to_next_modules = collect([]);

		    $next_modules->each(function ($module) use ($all_modules, $add_to_next_modules) {

		        $all_modules->push($module);
		        
		        $module->module->modules->each(function ($m) use ($add_to_next_modules) {
		            $add_to_next_modules->push($m);
		        });


		    });

		    if ($add_to_next_modules->count() > 0) {
		        $next_modules = $add_to_next_modules;
		    } else {
		        $next_modules = null;
		    }
		}

		return $all_modules;
	}


	public function module_from()
	{

		return $this->hasOne('App\GearModule', 'module_id', 'id');
	}

	public function company()
	{

		return $this->belongsTo('App\Company', 'company_id', 'id');
	}

	public function getNameAttribute()
	{

		$brand = $this->brand->name;
		$model = $this->model->name;

		return "{$brand} - {$model}";
	}

	public function getBrandTypeAttribute()
	{

		$brand_type = \App\BrandType::where('brand_id', $this->brand->id)->where('type_id', $this->type->id)->first();

		return $brand_type;
	}

	public function get_contract()
	{

		return $this->belongsTo('App\Contract', 'contract_id', 'id');
	}

	public function get_coverage()
	{

		return $this->belongsTo('App\Coverage', 'coverage_id', 'id');
	}

	public function getCoverageAttribute()
	{

		if($this->get_coverage){
			return $this->get_coverage;
		}elseif($this->master_coverage){
			return $this->company->master_parent->coverage;
		}else{
			return null;
		}
	}

	public function getContractAttribute()
	{

		if($this->get_contract){
			return $this->get_contract;
		}elseif($this->master_contract){
			return $this->company->master_parent->contract;
		}else{
			return null;
		}
	}

	public function getContractEndAtAttribute()
	{

		$start_at = $this->contract_id ? $this->contract_start_at : $this->company->contract_start_at;

	    $contract_end_at = null;

	    if ($this->contract->period_format == 'd') {
	        $contract_end_at = \Carbon\Carbon::parse($start_at)->addDays($this->contract->period_number);
	    } elseif ($this->contract->period_format == 's') {
	        $contract_end_at = \Carbon\Carbon::parse($start_at)->addWeeks($this->contract->period_number);
	    } elseif ($this->contract->period_format == 'm') {
	        $contract_end_at = \Carbon\Carbon::parse($start_at)->addMonths($this->contract->period_number);
	    } elseif ($this->contract->period_format == 'y') {
	        $contract_end_at = \Carbon\Carbon::parse($start_at)->addYears($this->contract->period_number);
	    }

	    return $contract_end_at;
	}

	public function getContractInitAttribute()
	{

		return $this->contract_id ? $this->contract_start_at : $this->company->contract_start_at;
	}

	public function getContractLifeAttribute()
	{


		if($this->contract_id){

			$start = \Carbon\Carbon::parse($this->contract_start_at)->format('d/m/Y');
			$end = \Carbon\Carbon::parse($this->contract_end_at)->format('d/m/Y');
			
		}else{

			$start = \Carbon\Carbon::parse($this->company->contract_start_at)->format('d/m/Y');
			$end = \Carbon\Carbon::parse($this->company->contract_end_at)->format('d/m/Y');

		}

		return "{$start} - {$end}";
	}

	public function coverage()
	{

		return $this->belongsTo('App\Coverage', 'coverage_id', 'id');
	}

	public function stock()
	{
		$this->hasOne('App\Stock', 'gear_id', 'id');
	}

	public function getInventoryAttribute()
	{
		return optional($this->stock)->inventory;
	}
}

laravel/app/GearType.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class GearType extends Model
{

		protected $table   = 'gear_types';
	    public $timestamps = true;
	    protected $guarded = [];

    public function brands(){

    	return $this->hasMany('App\GearBrand', 'type_id', 'id');

    }
}

laravel/resources/views/helpdesk/gears/partials/assign_gear_to_site.blade.php
<form action="{{ route('reassign_gear_to_zone', $g->id) }}" method="post" class="d-flex align-items-center">
	

	{{ csrf_field() }}


	<select name="company_id" class="form-control" style="border-radius: 3px 0 0 3px">
		<option disabled selected value>Elige una opción</option>
		
		@foreach($company->all_childs() as $child)
		

		<option value="{{ $child->id }}" {{ $g->company->id == $child->id ? 'selected' : '' }} >
			

			{{ $child->name }}


		</option>


		@endforeach

	</select>


	<button class="btn btn-success" style="border-radius: 0 3px 3px 0">
		<i class="fa fa-check" style="margin: 0 !important"></i>
	</button>

	
</form>

laravel/resources/views/helpdesk/gears/partials/edit_module_form.blade.php
{{ csrf_field() }}
{{ method_field('PATCH') }}

<div v-if="edit_module">

	<div class="form-row">
		<label class="col-sm-3 col-form-label text-right">Slot:</label>
		<div class="form-group col-sm-4">
			<input type="text" name="slot" :value="edit_module.slot" class="form-control">
		</div>
	</div>

	<div class="form-row">
		<label class="col-sm-3 col-form-label text-right">Descripción:</label>
		<div class="form-group col-sm-6">
			<textarea name="description" rows="4" class="form-control">@{{ edit_module.description }}</textarea>
		</div>
	</div>

	<div class="form-row">
		<div class="col-sm-6 mx-auto">
			<div class="form-group">
				<div class="custom-control custom-checkbox">
				  <input type="checkbox" 
				  		 class="custom-control-input" 
				  		 id="slotWithModuleInModal" 
				  		 :checked="edit_module_add_gear"
				  		 @change.prevent="add_gear_to_module_in_modal">

				  <label class="custom-control-label" for="slotWithModuleInModal">Hay equipo instalado en el módulo</label>
				</div>
			</div>
		</div>
	</div>
	
	<div v-if="edit_module_add_gear">
		<div class="form-row">
			<div class="col-sm-6 mx-auto">
				<p class="text-info">
					Adjunta un equipo existente a traves de el número de serie.
				</p>
			</div>
		</div>

		<div class="form-row">
			<label class="col-sm-3 col-form-label text-right"># Serie:</label>
			<div class="form-group col-sm-4">
				<input type="text" 
					   name="existing_serial_number"
					   class="form-control serial_numbers_input_in_modal" 
					   :value="edit_module.module ? edit_module.module.serial_number : ''" 
					   placeholder="Ingresa el número de serie..." 
					   required>
			</div> 	
		</div>

		<div class="form-row">
			<div class="form-group col-sm-6 mx-auto">
				<a href="#" class="btn btn-link p-0">O bien, crea un nuevo equipo</a>
			</div>
		</div>
	</div>

</div>

<div class="form-row" v-else>
	<div class="col-sm-6 mx-auto">
		<p class="m-0"><i class="fa fa-spin fa-spinner mr-2 fa-lg"></i> Cargando Información...</p>
	</div>
</div>

laravel/resources/views/helpdesk/gears/partials/module-form.blade.php
{{ csrf_field() }}

<div class="form-row">
	<label class="col-form-label col-sm-4 text-right">
		<span class="text-danger">*</span>
		Módulo / Slot
	</label>
	<div class="form-group col-sm-3">
		<input type="text" name="slot" class="form-control" required>
	</div>
</div>

<div class="form-row">
	<label class="col-form-label col-sm-4 text-right">Descripción:</label>
	<div class="form-group col-sm-4">
		<textarea name="description" rows="4" class="form-control"></textarea>
	</div>
</div>

<div class="form-row form-group d-flex align-items-center">
	<label class="col-form-label col-sm-4 text-right"><span class="text-danger">*</span> # Serie:</label>
	<div class="col-sm-4">
		<input type="text" name="serial_number" class="form-control serial_numbers_input" placeholder="Ingresa el número de serie..." required autocomplete="off">
	</div>
	<div class="col-sm-4">
		<a href="#" v-if="!create_new_gear" @click.prevent="go_to_create_new_gear" class="btn btn-link p-0">
			<i class="fa fa-plus"></i> Nuevo Equipo
		</a>
		<a href="#" v-else @click.prevent="cancel_new_gear_creation" class="text-danger"><i class="fa fa-times"></i> Cancelar</a>
	</div>
</div>

<div v-if="create_new_gear" id="createNewGear">
	
	<input type="hidden" name="new_gear">

	<div class="form-row">
		<div class="col-sm-4 offset-sm-4">
			<p class="text-info">Llena los siguientes campos para dar de alta un nuevo equipo.</p>
		</div>
	</div>
	
	<div class="form-row" @change="get_types">
		<label class="col-form-label col-sm-4 text-right"><span class="text-danger">*</span> Marca:</label>
		<div class="form-group col-sm-4">
			<select name="brand_id" id="brands_select" class="form-control" required>
				<option disabled selected value>Elige una opción</option>
				<option v-for="(brand, index) in brands" :value="brand.id">@{{ brand.name }}</option>
			</select>
		</div>
	</div>

	<div class="form-row" v-if="types">
		<label class="col-form-label col-sm-4 text-right"><span class="text-danger">*</span> Tipo:</label>
		<div class="form-group col-sm-4">
			<select name="type_id" class="form-control" @change="get_models" id="types_select" required>
				<option disabled selected value>Elige una opción</option>
				<option v-for="type in types" :value="type.id">@{{ type.name }}</option>
			</select>
		</div>
	</div>

	<div class="form-row" v-if="models">
		<label class="col-form-label col-sm-4 text-right"><span class="text-danger">*</span> Modelo:</label>
		<div class="form-group col-sm-4">
			<select name="model_id" id="models_select" class="form-control" required>
				<option disabled selected value>Elige una opción</option>
				<option v-for="model in models" :value="model.id">@{{ model.name }}</option>
			</select>
		</div>
	</div>

	<div class="form-row">
		<label class="col-form-label col-sm-4 text-right"><span class="text-danger">*</span> # Serie:</label>
		<div class="form-group col-sm-4">
			<input type="text" name="serial_number" class="form-control">
		</div>
	</div>

</div>

laravel/resources/views/helpdesk/gears/partials/scripts-show.blade.php
<script>
	
	var gearApp = new Vue({

		el: '#companyApp',
		data: {
			serial_numbers: @json($company->gears()->where('serial_number', '<>', $gear->serial_number)->pluck('serial_number')),
			gear_in_module: false,
			create_new_gear: false,
			brands: @json(App\GearBrand::get()),
			types: null,
			models: null,
			edit_module: null,
			edit_module_add_gear: false
		},
		mounted: function(){
			var t = this;
			var serial_numbers_input = $('.serial_numbers_input');	

			t.get_serial_numbers(serial_numbers_input);


			t.drag_drop_gear();

		},
		methods:{

			get_serial_numbers: function(el){

				var t = this;

			    el.autocomplete({
			      	source: t.serial_numbers
			    });

			},

			scroll_to_modules: function(){

				var t = this;
				var modules = $('#modules');

				setTimeout(function(){

					$('html, body').animate({scrollTop: modules.offset().top - 72});
					$('[name="slot"]').focus();

				}, 300);

			},

			add_gear_to_module: function(e){

				var t = this;

				var checkbox = $(e.target);

				var checked = checkbox.is(':checked');

				if(checked){

					t.gear_in_module = true;

					setTimeout(function(){

						var serial_numbers_input = $( ".serial_numbers_input" );

						t.get_serial_numbers(serial_numbers_input);

						var module_form = $('#gearInModule');

						$('html, body').animate({scrollTop: module_form.offset().top - 72});

						$('[name="existing_serial_number"]').focus();

					}, 300);

				}else{

					t.gear_in_module = false;

					t.create_new_gear = false;

					t.types = null;

					t.models = null;

				}

			},

			add_gear_to_module_in_modal: function(e){

				var t = this;

				var checkbox = $(e.target);

				var is_checked = checkbox.is(":checked");

				if(is_checked){
					t.edit_module_add_gear = true;
					setTimeout(function(){
						var serial_numbers_input = $( ".serial_numbers_input_in_modal" );

						t.get_serial_numbers(serial_numbers_input);
					}, 150);
				}else{
					t.edit_module_add_gear = false;
				}

			},

			go_to_create_new_gear: function(e){

				var t = this;

				t.create_new_gear = true;

				var serial_number_input = $('[name="serial_number"]');

				serial_number_input.attr('disabled', 'disabled');

				setTimeout(function(){

					var create_new_gear = $('#createNewGear');

					$('html, body').animate({scrollTop: create_new_gear.offset().top - 72});

				}, 150);

			},

			cancel_new_gear_creation: function(){

				var t = this;

				t.create_new_gear = false;

				$('[name="serial_number"]').removeAttr('disabled');

				setTimeout(function(){

					var serial_numbers_input = $('.serial_numbers_input');

					t.get_serial_numbers(serial_numbers_input);

					t.types = null;

					t.models = null;

				}, 150);

			},

			get_types: function(e){

				var t = this;
				var select = $(e.target);
				var value = select.val();
				var types_select = $('#types_select');
				var url = '{{ route("brands.types.index", "#brand_id") }}';
				url = url.replace('#brand_id', value);

				t.models = null;
				types_select.val($('option:first', types_select).val());

				t.$http.get(url).then(function(response){
					t.types = response.body;
				});

			},

			get_models: function(e){
				
				var t = this;
				var brand = $('#brands_select').val();
				var select = $(e.target);
				var value = select.val();
				var models_select = $('#models_select');
				var url = '{{ route('brands.types.models.index', ['#brand_id', '#type_id']) }}';

				url = url.replace('#brand_id', brand).replace('#type_id', value);

				models_select.val($('option:first', models_select).val());

				t.$http.get(url).then(function(response){

					t.models = response.body;

				});

			},

			@include('helpdesk.gears.components.scripts.drag-and-drop')

		}

	});

</script>

laravel/resources/views/helpdesk/gears/partials/scripts.blade.php
<script>
	var gears = new Vue({
		el: '#gears_app',
		data: {
			brands: @json(App\GearBrand::get()),
			@isset($gear)
				types: @json(App\GearType::select(['id','name'])->get()),
				models: @json(App\GearModel::select(['id','name'])->where('brand_type_id', $gear->type_id)->get()),
				contract: '{{ $gear->contract_id ? true : false }}',
				coverage: '{{ $gear->coverage_id ? true : false }}',
				modules: @json($gear->modules()->with('module')->get()->pluck('module.serial_number')),
			@else
				types: null,
				models: null,
				contract: false,
				coverage: false,
				serial_numbers: [],
				stock_gear: null,
				inventories: @json(App\Inventory::get()),
				inventory_stock: null,
			@endisset
			@isset ($inventory)
			    sites: null,
			@endisset
			loading_types: false,
			loading_models: false
		},
		mounted: function(){
			@isset($gear)

				$('[name="type_id"] option[value="{{ $gear->type->id }}"]').attr('selected', true);
				$('[name="brand_id"] option[value="{{ $gear->brand->id }}"]').attr('selected', true);
				$('[name="model_id"] option[value="{{ $gear->model->id }}"]').attr('selected', true);
				
			@endisset

			this.drag_drop_gear();
		},
		methods: {
			@isset ($inventory)
				get_sites: function(e){
					var t = this;
					var select = $(e.target);
					var company = select.val();
					var url = '{{ route('companies.gears.index', '#company_id') }}';
					
					t.sites = null;
					if(select){
						url = url.replace('#company_id', company);

						$.get(url, function(response){
							t.sites = response.zones;
						});
					}
				},
			@endisset
			get_types: function(e){

				var t = this;
				var select = $(e.target);
				var value = select.val();
				var types_select = $('#types_select');
				var url = '{{ route("brands.types.index", "#brand_id") }}';
				url = url.replace('#brand_id', value);

				t.models = null;
				t.loading_types = true;
				types_select.val($('option:first', types_select).val());

				t.$http.get(url).then(function(response){
					t.types = response.body;
					t.loading_types = false;
				});
			},
			get_models: function(e){
				
				var t = this;
				var brand = $('#brands_select').val();
				var select = $(e.target);
				var value = select.val();
				var models_select = $('#models_select');
				var url = '{{ route('brands.types.models.index', ['#brand_id', '#type_id']) }}';

				url = url.replace('#brand_id', brand).replace('#type_id', value);

				t.loading_models = true;

				models_select.val($('option:first', models_select).val());

				t.$http.get(url).then(function(response){

					t.models = response.body;
					t.loading_models = false;

				});
			},
			set_contract: function(e){
				var t = this;
				var select = $(e.target);
				var value = select.val();
				if(value){
					t.contract = true;

					setTimeout(function(){

						$( ".datepicker" ).datepicker({
							monthNames: ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"],
							monthNamesShort: ["Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic"],
							dayNames: ["Domingo", "Lunes", "Martes", "Miercoles", "Jueves", "Viernes", "Sábado"],
							dayNamesShort: ["Dom", "Lun", "Mar", "Mie", "Jue", "Vie", "Sab"],
							dayNamesMin: ["Do", "Lu", "Ma", "Mi", "Ju", "Vi", "Sa"],
						});

					}, 150);
				}else{
					t.contract = false;
				}
			},
			add_master_contract: function(e){

				var t = this;
				var checkbox = $(e.target);
				var select = $('[name="contract_id"]');

				if(checkbox.is(':checked')){
					select.attr('disabled', 'disabled').val($('option:first', select).val());
					t.contract = false;
				}else{
					select.removeAttr('disabled');
					select.val($('option:eq(1)', select).val());
					t.contract = false;
				}
			},
			add_master_coverage: function(e){

				var t = this;
				var checkbox = $(e.target);
				var select = $('[name="coverage_id"]');

				if(checkbox.is(':checked')){
					select.attr('disabled', 'disabled').val($('option:first', select).val());
					t.coverage = false;
				}else{
					select.removeAttr('disabled');
					select.val($('option:eq(1)', select).val());
					t.coverage = false;
				}
			},
			choose_stock_gear: function(e){

				var t = this;

				var checkbox = $(e.target);

				var checked = checkbox.prop('checked');
				
				if(checked){

					t.stock_gear = true;

				}else{

					t.stock_gear = null;

				}
			},
			get_inventory_gear: function(e){

				var t = this;

				var select = $(e.target);

				var value = select.val();

				var route = '{{ route('inventories.stock.index', '#inventory_id') }}';

				route = route.replace('#inventory_id', value);

				t.$http.get(route).then(function(response){

					t.inventory_stock = response.body;

				});
			},			
			@include('helpdesk.gears.components.scripts.drag-and-drop')
		}
	});
</script>